;(function ( $ ) {
	$( document ).ready( function () {
		window.frenzyFetch = {
			state : {
				currentlyEditingCarousel : '',
				post_content : '',
				reschedule : false,
				galleryEditQueryRan : false,
				carouselSidebarReset : false
			},

			modal : new wp.media.view.Modal( {
				controller : {
					trigger : function () {
					}
				}
			} ),

			updatePostContent : function ( content ) {
				this.state.post_content = content;
			},

			getPostContent : function () {
				return this.state.post_content;
			},

			resetRescheduleFlag : function () {
				this.state.reschedule = false;
				this.state.post_content = this.getContentFromEditor();
			},

			getContentFromEditor : function () {
				let content = '';
				if ( window.frenzyFetch.gutenberg.isGutenbergActive() ) {
					content = window.frenzyFetch.gutenberg.getEditorContent();
				} else {
					content = tinyMCE.editors[ 0 ].getContent();
				}

				return content;
			},

			openProductCarousel : function () {
				window.frenzyFetch.productCarousel.state.hasBeenOpened = true;
				window.frenzyframe.close();
				window.frenzyFetch.modal.close();
				wp.media.frenzy.frame.open();
				wp.media.frenzy.frame.setState( 'product-gallery' );
				window.frenzyFetch.productCarousel.resetCarouselEditView();
				$( '#fetch-product-carousel .media-router .media-menu-item' ).eq( 1 ).click();
			},

			$loadingSpinner : $( '<div class="fetch-loading-spinner lds-ring"><div></div><div></div><div></div><div></div></div>' ),

			waitForEl : function ( selector, callback ) {
				if ( jQuery( selector ).length ) {
					callback();
				} else {
					setTimeout( function () {
						window.frenzyFetch.waitForEl( selector, callback );
					}, 100 );
				}
			},

			loadImagesInSidebarForProduct( productId ) {
				$( '.frenzy-show-on-image-holder' ).html( this.$loadingSpinner );

				jQuery.ajax( {
					url : ajaxurl + '?action=frenzy_get_product_info',
					data : {
						post_id : wp.media.view.settings.post.id,
						product_id : productId
					},
					type : 'POST',
					success : function ( response ) {
						var imgs = '';
						imgs += '<div class="fetch-show-on-image-container fetch-product-carousel-option-container">' +
							'<input type="checkbox" ' +
							'name="product-carousel" ' +
							'class="fetch-show-on-checkbox" ' +
							'value="' + wp.media.view.settings.post.id + '" ' +
							'id="product-carousel" ' + response.data.product_carousel + ' />' +
							'<label class="setting fetch-show-on-product-carousel-setting" for="product-carousel" data-setting="ims"><div class="inner-setting">Product Carousel</div></label>' +
							'</div>';
						for ( img in response.data.imgs ) {
							imgs += '<div class="fetch-show-on-image-container">' +
								'<input type="checkbox" name="product_images" class="fetch-show-on-checkbox" value="' +
								response.data.imgs[ img ].id +
								'" id="' +
								response.data.imgs[ img ].id +
								'" ' +
								response.data.imgs[ img ].checked + '/>' +
								'<label class="setting" for="' + response.data.imgs[ img ].id + '" data-setting="ims"><img  src=' + response.data.imgs[ img ].url + ' draggable="false"></label>' +
								'</div>';
						}
						imgs += '<span class="settings-save-status"><div id="prod-id" data-id="' + productId + '"></div><button type="button" class="button frenzy-force-save-attachment-details">Save Changes</button></span>';
						$( '.frenzy-show-on-image-holder:visible' ).html( imgs );

						// Remove the add to carousel button on the shop button frame.
						$( '#frenzy-shop-buttton-frame .fetch-product-carousel-option-container' ).remove();
						$( '#fetch-product-carousel .fetch-product-carousel-option-container' ).remove();
					}
				} );
			},

			openEditProductCarousel : function ( values ) {
				window.frenzyFetch.productCarousel.state.hasBeenOpened = true;
				window.frenzyFetch.productCarousel.state.editHasBeenOpened = true;

				let ids = values.ids;
				if ( 'undefined' === typeof values.type ) {
					values.type = '';
				}

				window.frenzyframe.close();
				window.frenzyFetch.modal.close();
				wp.media.frenzy.frame.open();

				// If we opened via Gutenberg and aren't editing something with values.
				if ( window.frenzyFetch.gutenberg.state.current && '' === values.ids ) {
					// DO nothing..
					return;
				}

				wp.media.frenzy.frame.setState( 'fetch-product-carousel' );

				// Only run this 1 time, future runs cause issues.
				if ( !this.state.galleryEditQueryRan ) {
					wp.media.frenzy.frame.state( 'gallery-edit' ).set( 'library', this.fetchQueryForProductsEdit( ids ) );
					wp.media.frenzy.frame.setState( 'gallery-edit' );
				} else {
					this.productCarousel.hydrateEditLibrary();
				}

				wp.media.frenzy.frame.setState( 'fetch-product-carousel' );
				wp.media.frenzy.frame.setState( 'gallery-edit' );
				window.frenzyFetch.productCarousel.state.type = values.type;

				this.waitForEl( '.collection-settings.gallery-settings .columns', function () {
					if ( '' === values.type ) {
						values.type = 'carousel';
					}

					$( '.collection-settings.gallery-settings .columns' ).val( values.type );
					wp.media.frenzy.frame.states.get( 'gallery-edit' ).set( 'columns', values.type );
					
					
					window.frenzyFetch.addListenerForCarouselType();
				} );

				window.frenzyFetch.productCarousel.updateActionButtonText( 'Save' );

				this.waitForEl( '#fetch-product-carousel .attachment[data-id]', function () {
					wp.media.frenzy.frame.setState( 'fetch-product-carousel' );

					window.frenzyFetch.productCarousel.updateActionButtonText( 'Save' );
					let editCollection = wp.media.frenzy.frame.content.get().collection;
					let libraryProducts = editCollection.models;
					let splitIds = ids.split( ',' );
					let integerSplitIds = [];
					let removeProducts = [];


					splitIds.forEach( function ( value ) {
						integerSplitIds.push( parseInt( value ) );
					} );

					libraryProducts.forEach( function ( product ) {
						if ( integerSplitIds.includes( product.get( 'id' ) ) ) {
							return;
						}

						removeProducts.push( product );
					} );


					// Update collection, selection, and gallery.
					editCollection.remove( removeProducts );
					window.frenzyFetch.refreshEditStateWithCollection( editCollection );
					$( '.currently-editing-carousel ul.attachments' ).sortable( 'enable' );
				} );
			},

			addListenerForCarouselType : function () {
				$( '.collection-settings.gallery-settings .columns' ).change( function () {
					window.frenzyFetch.productCarousel.state.type = $( this ).val();
					window.frenzyFetch.productCarousel.state.manuallyChanged = true;
					wp.media.frenzy.frame.states.get( 'gallery-edit' ).set( 'columns', window.frenzyFetch.productCarousel.state.type );
				} );
			},

			refreshEditStateWithCollection( collection ) {
				let selection = wp.media.frenzy.frame.state( 'gallery-edit' ).get( 'selection' );
				selection.forEach( function ( item ) {
					selection.remove( item );
				} );

				collection.forEach( function ( product ) {
					selection.add( product );
				} );
			},

			fetchQueryForProductsEdit( ids ) {
				this.state.galleryEditQueryRan = true;
				return new wp.media.query( {
					frenzyproducts : 'frenzyproducts',
					where : 'fetchQueryForProductsEdit',
					posts_per_page : 999,
					query : true,
				} );
			},

			fetchQueryForProducts() {
				return new wp.media.query( {
					frenzyproducts : 'frenzyproducts',
					where : 'fetchQueryForProducts',
					ignore : new Date(),
					posts_per_page : 999,
					query : true,
				} );
			},

			openShopFrame : function () {
				window.frenzyFetch.modal.close();
				wp.media.frenzy.frame.close();
				window.frenzyframe.open();
				$( '#frenzy-shop-buttton-frame .media-router .media-menu-item' ).eq( 1 ).click();

				// Wait for this element to get the drag and drop class and then remove that functionality.
				this.waitForEl( '.supports-drag-drop', function () {
					// $( '#frenzy-shop-buttton-frame' ).parents( '.supports-drag-drop' ).off();
				} );
			},

			init : function () {
				this.manualProducts.init();
				this.shopButton.init();
				this.productCarousel.init();
				this.gutenberg.init();
				this.bindEvents();
			},

			bindEvents : function () {
			},

			sidebar : wp.media.View.extend( {
				tagName : 'div',
				className : 'fetch-sidebar',
				template : wp.template( 'fetch-sidebar' ),
				events : {
					'click .js-toggle-shop-button' : 'openShopFrame',
					'click .js-toggle-product-carousel' : 'openProductCarousel',
					'click .js-toggle-manual-products' : 'openManualProducts',
				},

				attributes : function () {
					return {
						activeTab : 'default',
					}
				},

				openShopFrame : function () {
					window.frenzyFetch.openShopFrame();
				},

				openManualProducts : function () {
					window.frenzyframe.close();
					wp.media.frenzy.frame.close();
					window.frenzyFetch.manualProducts.open();
				},

				openProductCarousel : function () {
					window.frenzyFetch.openProductCarousel();
				},

				setActiveTab : function ( tab ) {
					$( 'body' ).find( '.fetch-sidebar .media-menu-item' ).removeClass( 'active' );
					$( 'body' ).find( '.fetch-sidebar .js-toggle-' + tab ).addClass( 'active' );
				}
			} ),

			manualProducts : {
				modalContentView : wp.Backbone.View.extend( {
					template : wp.template( 'manual-products' )
				} ),

				state : {
					productData : {
						queryParams : {
							page : 1
						}
					},
					latestAjaxResponse : {},
					sidebarHasBeenAdded : false,
					sidebar : {},
				},

				init : function () {
					window.frenzyFetch.modal.content( new this.modalContentView() );
					this.bindEvents();
				},

				bindEvents : function () {
					$( 'body' ).on( 'click', '.js-load-more-manual-products', this.loadMoreProducts.bind( this ) );
					$( 'body' ).on( 'click', '#js-search-shopstyle', this.submitSearch.bind( this, event ) );
					$( 'body' ).on( 'click', '.shopstyle-product-item', { this : this }, this.viewDetails );
					$( '.js-manual-products-btn' ).click( this.openClickEvent.bind( this ) );
				},

				openClickEvent : function ( event ) {
					event.preventDefault();
					this.open();
				},

				open : function () {
					window.frenzyframe.close();
					wp.media.frenzy.frame.close();
					window.frenzyFetch.modal.open();

					this.maybeRenderSidebar();
					shopStyleApplyChosen();
					shopStyleRemoveLoadingIndicator();
					shopStyleResetSearchFilterForm();

					if ( 'undefined' === typeof this.state.latestAjaxResponse.success ) {
						let queryParams = shopStyleGetQueryParams();
						shopStyleGetProducts( queryParams );
					}
				},

				maybeRenderSidebar : function () {
					if ( true === this.state.sidebarHasBeenAdded ) {
						return;
					}
					this.state.sidebar = new window.frenzyFetch.sidebar( {
						el : '.fetch-manual-product-sidebar-container',
						activeTab : 'manual-products'
					} );
					this.state.sidebar.render();

					this.state.sidebarHasBeenAdded = true;
				},

				loadMoreProducts : function () {
					let productData = this.state.productData;
					let nextPage = productData.queryParams.page + 1;

					let queryParams = Object.assign( {}, productData.queryParams, {
						page : nextPage
					} );

					this.state.productData.queryParams = queryParams;
					shopStyleGetProducts( this.state.productData.queryParams, true );
				},

				submitSearch : function ( something, event ) {
					event.preventDefault();

					var queryParams = shopStyleGetQueryParams(),
						searchTerms = $( '#js-shopstyle-search' ).val();
					if ( searchTerms ) {
						queryParams.keywords = searchTerms;
					}
					window.location.hash = '';
					queryParams = Object.assign( {}, queryParams, getStyleSearchFilterParams( $( '#shopstyle-search-form select' ) ) );
					shopStyleGetProducts( queryParams );

					// Scroll up to the top.
					$( '.attachments' ).scrollTop( 0 );
				},

				viewDetails : function ( event ) {
					var $this = $( this ),
						eventThis = event.data.this,
						$product = $this;
					eventThis.state.viewingDetails = JSON.parse( $product.attr( 'data-product-details' ) );
					eventThis.state.productId = $product.attr( 'data-wp-product-id' );

					$( '.fetch-currently-viewing' ).removeClass( 'fetch-currently-viewing' );
					$product.addClass( 'fetch-currently-viewing' );
					eventThis.updateDetailsView();
				},

				updateDetailsView : function () {
					let $rightSidebar = $( '#manual-products .media-sidebar' );

					let sidebar_content = '<div class="attachment-details">' +
						'<h2>Fetch Product Details</h2>' +
						'<div class="attachment-info">' +
						'<div class="thumbnail thumbnail-product">' +
						'<img src="' + this.state.viewingDetails.image_url + '" draggable="false" alt="" />' +
						'</div>' +
						'<div class="details">' +
						'<div class="filename">' +
						this.state.viewingDetails.title +
						'</div>' +
						'<div class="uploaded"> Price: $' +
						this.state.viewingDetails.price +
						'</div>';

					if ( this.state.viewingDetails.manufacturer ) {
						sidebar_content += '<div class="uploaded">Brand: ' +
							this.state.viewingDetails.manufacturer +
							'</div>';
					}

					if ( this.state.viewingDetails.merchant_name ) {
						sidebar_content += '<div class="uploaded">Retailer: ' +
							this.state.viewingDetails.merchant_name +
							'</div>';
					}

					if ( this.state.viewingDetails.color ) {
						sidebar_content += '<div class="uploaded">Color: ' +
							this.state.viewingDetails.color +
							'</div>';
					}

					if ( this.state.viewingDetails.material ) {
						sidebar_content += '<div class="uploaded">Material: ' +
							this.state.viewingDetails.material +
							'</div>';
					}

					if ( this.state.viewingDetails.size ) {
						sidebar_content += '<div class="uploaded">Size: ' +
							this.state.viewingDetails.size +
							'</div>';
					}

					if ( this.state.viewingDetails.buy_url ) {
						sidebar_content += '<div class="uploaded"><a target="_blank" href="' + this.state.viewingDetails.buy_url + '">View Product Page</a> ' + '</div>';
					}
					
					sidebar_content += '</div></div>';
					
					if ( this.state.viewingDetails.user_commission ) {
						sidebar_content += '<div class="commission-amount">Commission Amount: $' + this.state.viewingDetails.user_commission + '</div><br>';
					}

					sidebar_content += '<div class="uploaded"><strong>Description:</strong></div><div class="uploaded">' + this.state.viewingDetails.description + '</div>' + '</div>' +
						'<h2 class="fetch-show-on-label">Add To' +
						'<div class="auto-selection-options">' +
						'<button class="js-check-all">Check all</button>' +
						'<button class="js-uncheck-all">Uncheck All</button>' +
						'</div>' +
						'<div class="fetch-help-tooltip fetch-add-to-tooltip">' +
						'<div class="fetch-tooltip-icon">?</div>' +
						'<div class="fetch-help-tooltip-content">' +
						'<div class="fetch-tooltip-arrow-up"></div>' +
						'<p>- Choose which Shop Button images you want this product to be added to.</p>' +
						'</div>' +
						'</div>' +
						'</h2>' +
						'<div class="frenzy-show-on-image-holder">' +
						'</div>';
					$( '#manual-products .attachment-details' ).remove();

					$rightSidebar.html( sidebar_content );
					window.frenzyFetch.loadImagesInSidebarForProduct( this.state.productId );
				},

				refreshManuallyAddedProducts : function () {
					$.ajax( {
						method : "POST",
						data : {
							'post_id' : frenzyWpSortable.postID
						},
						url : frenzyWpSortable.ajaxUrl + '?action=get_manually_added_products',
						dataType : "json",
					} ).success( function ( response ) {
						frenzyWpSortable.manuallyAddedProducts = response.data;

						$( '.shopstyle-product-item' ).each( function ( index, item ) {
							var $item = $( item ),
								id = $item.attr( 'data-id' );

							// Remove manually added class.
							$item.removeClass( 'is-manually-added' );

							fetchUpdateManualProductHtmlBasedOnIfItsAdded( $item, id );
						} );
					} ).error( function ( jsHXR, errorString, exceptionObj ) {
						alert( 'Something went wrong.' );
					} );
				}
			},

			shopButton : {
				modalContentView : wp.Backbone.View.extend( {
					template : wp.template( 'manual-products' )
				} ),
				state : {},
				init : function () {
					this.bindEvents();
				},
				bindEvents : function () {

				},
			},

			productCarousel : {
				state : {
					type : 'carousel',
					manuallyChanged : false,
					hasBeenOpened : false,
					editHasBeenOpened : false
				},
				init : function () {
					this.bindEvents();
				},
				bindEvents : function () {
				},

				resetCarouselTab : function () {
					if ( !this.state.hasBeenOpened && !this.state.editHasBeenOpened ) {
						return;
					}

					this.resetCarouselEditView();
					this.resetCarouselGalleryView();
					window.frenzyFetch.state.currentlyEditingCarousel = '';
					window.frenzyFetch.productCarousel.state.type = '';
					window.frenzyFetch.productCarousel.state.manuallyChanged = false;
				},

				resetCarouselEditView : function () {
					if ( !this.state.editHasBeenOpened ) {
						return;
					}

					let productsToRemove = [];

					let selectedProducts = wp.media.frenzy.frame.state( 'gallery-edit' ).get( 'selection' );
					selectedProducts.forEach( function ( product ) {
						productsToRemove.push( product );
					} );
					wp.media.frenzy.frame.state( 'gallery-edit' ).get( 'selection' ).remove( productsToRemove );

					let libraryProducts = wp.media.frenzy.frame.state( 'gallery-edit' ).get( 'library' );
					productsToRemove = [];
					libraryProducts.forEach( function ( product ) {
						productsToRemove.push( product );
					} );

					wp.media.frenzy.frame.state( 'gallery-edit' ).get( 'library' ).remove( productsToRemove );
				},

				resetCarouselGalleryView : function () {
					if ( !this.state.hasBeenOpened ) {
						return;
					}

					let productsToRemove = [];

					// Remove existing products from gallery selection.
					wp.media.frenzy.frame.setState( 'product-gallery' );
					wp.media.frenzy.frame.state().get( 'selection' ).forEach( function ( product ) {
						productsToRemove.push( product );
					} );
					wp.media.frenzy.frame.state().get( 'selection' ).remove( productsToRemove );
				},

				hydrateEditLibrary : function () {
					wp.media.frenzy.frame.setState( 'gallery-edit' );

					let galleryLibrary = wp.media.frenzy.frame.state( 'product-gallery' ).get( 'library' );
					let productsToAdd = [];


					if ( galleryLibrary.length ) {
						galleryLibrary.forEach( function ( product ) {
							productsToAdd.push( product );
						} );
					}

					wp.media.frenzy.frame.content.get().collection.add( productsToAdd );
					window.frenzyFetch.refreshEditStateWithCollection( wp.media.frenzy.frame.content.get().collection );
				},

				updateActionButtonText( text ) {
					if ( window.frenzyFetch.state.currentlyEditingCarousel ) {
						let state = wp.media.frenzy.frame.state();
						if ( 'undefined' === typeof state || 'product-gallery' === wp.media.frenzy.frame.state().get( 'id' ) ) {
							text = 'Update Order of Products';
						} else {
							text = 'Save';
						}
					}

					$( '.media-toolbar-primary .media-button' ).text( text );
				}
			},

			gutenberg : {
				state : {
					current : false
				},

				isGutenbergActive : function () {
					return document.body.classList.contains( 'block-editor-page' );
				},

				getEditorContent : function () {
					return wp.data.select( "core/editor" ).getEditedPostContent();
				},

				getEditorTitle : function () {
					return wp.data.select( "core/editor" ).getEditedPostAttribute( 'title' );
				},

				getFeaturedImage : function () {
					return wp.data.select( 'core/editor' ).getEditedPostAttribute( 'featured_media' );
				},

				init : function () {
					let self = this;
					if ( !this.isGutenbergActive() ) {
						window.frenzyFetch.waitForEl( '.wp-editor-tools', function () {
							let $openShopFrame = $( '.open-shop-frame' );
							$( '.wp-editor-tools' ).append( $openShopFrame );
							self.maybeDisableFetchButtons();
						} );
						return;
					}

					// TODO: Use actual JS event to wait until Gutenberg is loaded.
					window.frenzyFetch.waitForEl( '.edit-post-header-toolbar', function () {
						var $openShopFrame = $( '.open-shop-frame' );
						$( '.edit-post-header-toolbar' ).append( $openShopFrame );
						self.maybeDisableFetchButtons();
					} );
				},

				maybeDisableFetchButtons : function () {
					if ( window.frenzyWpSortable.isFetchLoggedIn ) {
						return;
					}

					$( '.open-shop-frame' ).attr( 'disabled', 'disabled' ).addClass( 'fetch-not-logged-in' )
						.html( 'You must <a href="' + window.frenzyWpSortable.settingsUrl + '">log in</a> to Fetch</a> to add products.' );
				}
			}
		};

		function shopSimilarSortProducts() {
			$( '#js-shopsimilar-products-list' ).sortable( {
				stop : function ( event, ui ) {
					shopStyleAddLoadingIndicator();
					var productReordering = {},
						productNoReordering = {},
						reorderingNonce = $( '#_product_reordering_nonce' ).val();
					$( '.shopsimilar-products-order-list-item' ).each( function ( index, el ) {
						var $el = $( el ),
							productId = $el.attr( 'data-id' ),
							productIndex = $el.index();
						$el.attr( 'data-newindex', productIndex );
						var dataNewIndex = $el.attr( 'data-newindex' );
						if ( dataNewIndex !== $el.attr( 'data-oldindex' ) ) {
							productReordering[ dataNewIndex.toString() ] = productId;
						} else {
							productNoReordering[ productIndex.toString() ] = productId;
						}
					} );
					postData = Object.assign( {}, {
						action : frenzyWpSortable.reoderingAction,
						reorderingNonce : reorderingNonce,
						postID : frenzyWpSortable.postID
					} );
					postData.orderingData = Object.assign( {}, productReordering, productNoReordering );

					$.ajax( {
						method : "POST",
						action : frenzyWpSortable.reoderingAction,
						url : frenzyWpSortable.ajaxUrl,
						data : postData,
						dataType : "json",
					} ).success( function ( response ) {
						shopSimilarProductListShowUpdateMsg( 'Product Order Updated', ui );
						shopStyleRemoveLoadingIndicator();
					} ).error( function ( jsHXR, errorString, exceptionObj ) {
						shopStyleRemoveLoadingIndicator();
					} );
				}

			} );

		}

		function shopStyleResetSearchFilterForm() {
			$( '#shopstyle-search-form' )
				.find( 'input[type=text]' ).val( "" )
				.end()
				.find( 'select' ).each( function () {
				$( this ).val( '' ).trigger( 'chosen:updated' );
			} );

			$( '#js-reset-filters' ).on( 'click', function ( e ) {
				e.preventDefault();
				shopStyleResetSearchFilterForm();
				$( '#shopstyle-search-form select' ).first().trigger( 'change' );
			} );
		}

		function shopStyleApplyChosen() {
			let $filterSelectMenus = $( 'body' ).find( '.shopstyle-filters select' ),
				queryParams;

			$filterSelectMenus.chosen().on( 'change', function () {
					queryParams = Object.assign( {}, queryParams, getStyleSearchFilterParams( $filterSelectMenus ) );
					shopStyleGetProducts( queryParams );
					$( '.attachments' ).scrollTop( $( '.attachments' ).scrollHeight );
				}
			);
		}

		function getStyleSearchFilterParams( $filterSelectMenus ) {
			let queryParams = {
				'price-min' : '',
				'price-max' : '',
				'manufacturer' : '',
				'merchant' : '',
				'color' : '',
				'keywords' : $( '#js-shopstyle-search' ).val()
			};

			$filterSelectMenus.each( function ( index ) {
					var $select = $( this ),
						$selectedOption = $select.find( ':selected' ),
						selectedOptionValue = $selectedOption.val(),
						selectName = $select.attr( 'name' ),
						queryParamParts = selectedOptionValue.split( "=" );

					// $select.attr( 'disabled', 'disabled' );

					if ( selectedOptionValue ) {
						if ( 'brands' === selectName ) {
							queryParams[ 'manufacturer' ] = queryParamParts[ 0 ];
						} else if ( 'retailers' === selectName ) {
							queryParams[ 'merchant' ] = queryParamParts[ 0 ];
						} else if ( 'color' === selectName ) {
							queryParams[ 'color' ] = queryParamParts[ 0 ];
						}
					}
				}
			);

			return queryParams;
		}

		function shopStyleGetProducts( queryParams, appendResults ) {
			if ( 'undefined' === typeof appendResults ) {
				appendResults = false;
			}

			shopStyleAddLoadingIndicator();

			var $availableShopStyleProductsList = $( '#js-shopstyle-available-products-list' ),
				productData = Object.assign( {}, {
					action : frenzyWpSortable.addProductAction,
					addProductNonce : $( '#_add_shopstyle_products_nonce' ).val(),
					queryParams : queryParams
				} );

			if ( 'undefined' === typeof productData.queryParams.keywords ) {
				productData.queryParams.keywords = 'nordstrom.com';
			}

			if ( 'undefined' === typeof productData.queryParams.page ) {
				productData.queryParams.page = 1;
			}

			if ( '' !== $( '[name="filter-price-min"]' ).val() ) {
				productData.queryParams[ 'price-min' ] = $( '[name="filter-price-min"]' ).val();
			}

			if ( '' !== $( '[name="filter-price-max"]' ).val() ) {
				productData.queryParams[ 'price-max' ] = $( '[name="filter-price-max"]' ).val();
			}

			if ( '' !== $( '[name="filter-color"]' ).val() ) {
				productData.queryParams[ 'color' ] = $( '[name="filter-color"]' ).val();
			}

			window.frenzyFetch.manualProducts.state.productData = productData;
			$.ajax( {
				url : frenzyWpSortable.ajaxUrl,
				method : "POST",
				data : productData,
				dataType : "json",
				action : frenzyWpSortable.addProductAction
			} ).done( function ( response ) {
				window.frenzyFetch.manualProducts.state.latestAjaxResponse = response;

				if ( response.success && response.data.products ) {
					if ( response.data.products.length ) {
						var productItemsHtml = '',
							productMetadata = response.data.metadata,
							productData = response.data.products,
							alreadyAddedProducts = shopStyleGetAlreadyAddedProducts();

						$.each( productData, function ( index, singleProduct ) {
							// Need all the HTML, including the parent element.
							var $productItemsContainer = $( $( frenzyWpSortable.shopStyleProductItemHtml ).prop( 'outerHTML' ) ),
								$addToWpButton = $productItemsContainer.find( '.add-product-to-wordpress' );

							fetchUpdateManualProductHtmlBasedOnIfItsAdded( $productItemsContainer, singleProduct.sku );

							$productItemsContainer.attr( 'data-post-id', frenzyWpSortable.postID );
							$productItemsContainer.attr( 'data-id', singleProduct.sku );
							$productItemsContainer.attr( 'data-product-details', JSON.stringify( singleProduct ) );
							$productItemsContainer.find( '.price' ).text( '$' + singleProduct.price );
							$productItemsContainer.find( '.photo' ).attr( 'src', singleProduct.image_url ).attr( 'alt', singleProduct.title );

							$productItemsContainer.find( '.brand' ).text( singleProduct.manufacturer ? singleProduct.manufacturer : '' );
							if ( ! singleProduct.manufacturer ) {
								$productItemsContainer.find( '.brand' ).text( singleProduct.merchant_name ? singleProduct.merchant_name : '' );
							}

							$productItemsContainer.find( '.product' ).text( singleProduct.title ? singleProduct.title : '' );

							let productId = singleProduct.mpn ? singleProduct.mpn : '';
							$addToWpButton.attr( 'data-product-id', productId );

							if ( Object.keys( alreadyAddedProducts ).indexOf( productId.toString() ) > -1 ) {
								$productItemsContainer.addClass( 'added' ).find( '.add-product-to-wordpress' ).addClass( 'added' ).text( frenzyWpSortable.buttonProductAddedText );
							}

							productItemsHtml += $productItemsContainer.prop( 'outerHTML' );
						} );


						shopStyleRemoveLoadingIndicator();
						if ( appendResults ) {
							$availableShopStyleProductsList.append( productItemsHtml );
						} else {
							$availableShopStyleProductsList.html( productItemsHtml );
						}
					} else {
						shopStyleShowNoProductsFound();
					}
				} else {
					shopStyleShowNoProductsFound();
				}

				// $( 'body' ).find( '#shopstyle-search-form' ).find( 'select' ).removeAttr( 'disabled' );
			} );
		}

		function fetchUpdateManualProductHtmlBasedOnIfItsAdded( $item, manualId ) {
			if ( fetchProductIsManuallyAdded( manualId ) ) {
				$item.addClass( 'is-manually-added' );
				$item.attr( 'data-wp-product-id', frenzyWpSortable.manuallyAddedProducts[ manualId ] );
				$item.prepend( '<div class="fetch-ribbon"><span>Added</span></div>' );
			} else {
				$item.attr( 'data-wp-product-id', 123456789 );
			}
		}

		function fetchProductIsManuallyAdded( sku ) {
			if ( frenzyWpSortable.manuallyAddedProducts[ sku ] ) {
				return true;
			}

			return false;
		}

		function shopStyleGetAlreadyAddedProducts() {
			var $listItems = $( '#js-shopsimilar-products-list' ).find( 'li:not(#shopsimilar-products-order-list-item-template)' ),
				alreadyExistingProducts = [];

			$.each( $listItems, function ( index, value ) {
				var productId = $( this ).attr( 'data-id' );
				if ( productId ) {
					alreadyExistingProducts[ productId ] = productId;
				}
			} );

			return alreadyExistingProducts;
		}

		function shopStyleShowNoProductsFound() {
			$( '.load-more-manual-products-button' ).hide().after( '<p class="shopstyle-not-found">No products were found.</p>' );
			shopStyleRemoveLoadingIndicator();
			$( '.attachments' ).scrollTop( $('.shopstyle-not-found').offset().top );
		}

		function shopStyleAddLoadingIndicator() {
			$( '.shopstyle-ajax-loader' ).removeClass( 'invisible' );
			$( '.manual-products-body, #frenzy-meta-box-product-order .inside' ).addClass( 'loading' );

			// Make sure the load manual products option is there.
			$( '.load-more-manual-products-button' ).show();

			// Remove the no products found message since we're loading and will potentially find products.
			$( '.shopstyle-not-found' ).remove();
		}

		function shopStyleRemoveLoadingIndicator() {
			$( '.shopstyle-ajax-loader' ).addClass( 'invisible' );
			$( '.manual-products-body, #frenzy-meta-box-product-order .inside' ).removeClass( 'loading' );
		}

		function shopStyleGetQueryParams() {
			var queryParams = {},
				searchTerms = $( '#js-shoptyle-search' ).val();
			if ( searchTerms ) {
				queryParams.keywords = searchTerms;
			}

			return queryParams;
		}

		shopSimilarSortProducts();
		window.frenzyFetch.init();
	} )
	;

})
( jQuery );
