;(function ( $ ) {
	$( document ).on( 'tinymce-editor-init', function ( event, editor ) {
		window.frenzyFetch.updatePostContent( editor.getContent() );
	} );

	function dialog( yesCallback, noCallback ) {
		var dialog = $( '#frenzy_confirm_button' );
		dialog.show();

		$( '#btnYes' ).click( function () {
			dialog.hide();
			yesCallback();
		} );
		$( '#btnNo' ).click( function () {
			dialog.hide();
			noCallback();
		} );
	}

	function publishConfirmation() {
		const submitButton = document.querySelector( '#publishing-action input[name=publish]' );
		if ( submitButton ) {
			var frenzy_confirm_button = '<div id="frenzy_confirm_button" style="display:none;"><div class="title"><p>Oh no! You haven\'t added any products to your Frenzy widget!</p><p>Would you like to add them before you publish your post?</p></div><div id="btnYes" class="open-shop-frame">Yes, take me to the product editor</div><div id="btnNo">No, I don\'t want to add products</div></div>';
			$( '#wpcontent' ).append( frenzy_confirm_button );

			$( "body" ).on( "click", '#publishing-action input[name=publish]', frenzy_confirm_button_event );

			function frenzy_confirm_button_event( e ) {
				e.preventDefault();
				dialog(
					function () {
					},
					function () {
						$( "body" ).off( "click", '#publishing-action input[name=publish]', frenzy_confirm_button_event );
						$( '#publishing-action input[name=publish]' ).trigger( "click" );
					}
				);
			}
		}
	}

	publishConfirmation();

	function refreshShopButtonFrame() {
		if ( null === window.frenzyframe.content.get() ) {
			return;
		}

		window.frenzyframe.content.get().collection.props.set( { ignore : (+new Date()) } );
		$( '#frenzy-shop-buttton-frame .attachments' ).prepend( window.frenzyFetch.$loadingSpinner.css( { 'marginTop' : '20px' } ) );
		handleAfterShopButtonLoads();

		// Handle the UI for when the post has or doesn't have images.
		if ( false === window.frenzyFetch.state.post_has_images ) {
			$( '.fetch-loading-spinner' ).remove();
			$( '.js-fetch-it' ).attr( 'disabled', 'disabled' );
			$( '#frenzy-shop-buttton-frame .attachments' ).prepend( '<p class="no-image-found">No images found for post.</p>' );
		} else {
			$( '.js-fetch-it' ).removeAttr( 'disabled' );
			$( '.no-image-found' ).remove();
		}
	}

	function updateCarouselButtonText( text ) {
		window.frenzyFetch.productCarousel.updateActionButtonText( text );
	}

	function handleAfterShopButtonLoads() {
		var waitForEl = function ( selector, callback ) {
			if ( jQuery( selector ).length ) {
				callback( jQuery( selector ) );
			} else {
				setTimeout( function () {
					waitForEl( selector, callback );
				}, 100 );
			}
		};

		waitForEl( '#frenzy-shop-buttton-frame .attachment-products', function () {
			$( '.fetch-loading-spinner' ).remove();

			$( '#frenzy-shop-buttton-frame .attachment-products' ).sortable( {
				deactivate : function ( event, ui ) {
					var $parentContainer = $( ui.item ).closest( '.attachment-products' );
					var $parentAttachment = $( ui.item ).closest( '.attachment' );
					var productOrder = [];

					$parentContainer.children( '.attachment-product' ).each( function ( index, item ) {
						productOrder.push( $( item ).attr( 'data-term-id' ) );
					} );

					$.post( frenzyWp.ajaxUrl, {
						postId : $parentAttachment.attr( 'data-id' ),
						productOrder : productOrder,
						action : 'frenzy_sort_order'
					}, function ( data, status ) {
					} );
				}
			} );

			$( 'body' ).on( 'click', '.button-product-remove', function ( e ) {
				let $elToRemove = $( e.target ).closest( '.attachment-product' );
				if ( $elToRemove.hasClass( 'disabled' ) ) {
					return;
				}

				$elToRemove.append( window.frenzyFetch.$loadingSpinner );
				$elToRemove.addClass( 'disabled' );

				$.post( frenzyWp.ajaxUrl, {
					img_id : $( e.target ).closest( 'li' ).attr( 'data-id' ),
					product_id : $( e.target ).closest( '.attachment-product' ).attr( 'data-term-id' ),
					action : 'frenzy_remove_product_from_image'
				}, function ( data, status ) {
					if ( !data.success ) {
						window.alert( 'Error removing product.' );
					}

					$elToRemove.remove();
				} );
			} );

			$( '#frenzy-shop-buttton-frame .attachment' ).each( function ( index, item ) {
				let productSrc = $( '#postimagediv img' ).attr( 'src' );
				if ( 'undefined' !== typeof productSrc ) {
					productSrc = productSrc.replace( /-\d+[Xx]\d+\./g, '.' );
				}

				let thumbnailSrc = $( item ).find( '.thumbnail' ).find( 'img' ).attr( 'src' ).replace( /-\d+[Xx]\d+\./g, '.' );
				if ( productSrc == thumbnailSrc ) {
					$( item ).addClass( 'is-featured-image' );
				}
			} );
		} );

		refreshProductCarouselFrame();
	}

	function refreshProductCarouselFrame() {
		// Only refresh the frame if it's been opened already. Otherwise we don't need to.
		if ( !window.frenzyFetch.productCarousel.state.hasBeenOpened ) {
			return;
		}

		wp.media.frenzy.frame.setState( 'product-gallery' );
		wp.media.frenzy.frame.state( 'product-gallery' ).set( 'library', window.frenzyFetch.fetchQueryForProducts() );

		// Flip states a couple times to trigger the re-fetch for products.
		wp.media.frenzy.frame.setState( 'gallery-edit' );
		wp.media.frenzy.frame.setState( 'product-gallery' );
		wp.media.frenzy.frame.setState( 'gallery-edit' );
		wp.media.frenzy.frame.setState( 'product-gallery' );

		// Refresh if it has been initiated already.
		if ( wp.media.frenzy.frame.content.get() ) {
			// Reset this so the edit works as expected.
			window.frenzyFetch.state.galleryEditQueryRan = false;
			window.frenzyFetch.productCarousel.resetCarouselEditView();
		}
	}

	$( document ).ready( function () {
		// Handle click for Frenzy shop button frame.
		$( 'body' ).on( 'click',
			'#frenzy-shop-buttton-frame .frenzy-force-save-attachment-details, ' +
			'#fetch-product-carousel .frenzy-force-save-attachment-details', function ( e ) {
				var images = {};
				var ims = $( "input[name='product_images']" );
				$.each( ims, function () {
					images[ $( this ).val() ] = $( this ).is( ":checked" )
				} );

				$( '.frenzy-force-save-attachment-details' ).after( window.frenzyFetch.$loadingSpinner );

				jQuery.ajax( {
					url : ajaxurl + '?action=frenzy_save_image_products',
					data : {
						post_id : wp.media.view.settings.post.id,
						images : images,
						product : $( "#prod-id" ).data( 'id' )
					},
					type : 'POST'
				} ).done( function () {
					refreshShopButtonFrame();
					$( '.frenzy-show-on-image-holder .fetch-loading-spinner' ).remove();
				} );
			} );

		$( 'body' ).on( 'change', '.fetch-show-on-checkbox', function () {
			$( '.frenzy-force-save-attachment-details' ).click();
		} );

		// Handle click in manual product frame.
		$( 'body' ).on( 'click', '#manual-products .frenzy-force-save-attachment-details', function ( e ) {
			var images = {};
			var ims = $( "input[name='product_images']" );
			$.each( ims, function () {
				images[ $( this ).val() ] = $( this ).is( ":checked" )
			} );

			$( '.frenzy-force-save-attachment-details' ).after( window.frenzyFetch.$loadingSpinner );

			jQuery.ajax( {
				url : ajaxurl + '?action=frenzy_save_image_products',
				data : {
					post_id : wp.media.view.settings.post.id,
					images : images,
					product_carousel : $( 'input[name="product-carousel"]' ).val(),
					productData : JSON.parse( $( '.fetch-currently-viewing' ).attr( 'data-product-details' ) )
				},
				type : 'POST'
			} ).done( function ( response ) {
				refreshShopButtonFrame();
				refreshProductCarouselFrame();
				window.frenzyFetch.manualProducts.refreshManuallyAddedProducts();
				$( '.frenzy-show-on-image-holder .fetch-loading-spinner' ).remove();
			} );
		} );

		// Handle back to add carousel addition screen from edit screen.
		$( 'body' ).on( 'click', '.js-back-to-add-carousel-screen', function () {
			window.frenzyFetch.productCarousel.state.hasBeenOpened = true;
			let selectedProducts = wp.media.frenzy.frame.state().get( 'library' );
			wp.media.frenzy.frame.setState( 'product-gallery' );
			window.frenzyFetch.productCarousel.resetCarouselGalleryView();

			// Add products from edit gallery selection to this selection.
			selectedProducts.forEach( function ( product ) {
				wp.media.frenzy.frame.state().get( 'selection' ).add( product ? [ product ] : [] );
			} );

			window.frenzyFetch.productCarousel.resetCarouselEditView();
			updateCarouselButtonText( 'Create Product Carousel' );
		} );

		var fetch_button = '<div id="fetch-progress"><h2>Fetch Progress</h2><div id="fetch-flex-container"><div class="fetch-container-bg"><div id="fetch-progress-container" class="fetch-container" style="width:0"><span>0%</span></div></div><button id="fetchprods" style="display: none;" class="open-shop-frame button view-products-after-success">View Products</button></div></div>';

		$( "body" ).on( "click", '.js-fetch-it', function ( event ) {
			$( '#wpcontent' ).append( fetch_button );
			event.preventDefault();
			fetch_schedule_call();
			$( this ).attr( 'disabled', 'disabled' );
		} );

		$( "body" ).on( "click", '.js-switch-to-manual-products', function ( event ) {
			window.frenzyFetch.manualProducts.open();
		} );

		function fetch_schedule_call() {
			//make api call to schedule the post to be frenzied
			jQuery.ajax( {
				url : ajaxurl + '?action=fetch_schedule_post',
				data : {
					post_id : wp.media.view.settings.post.id,
					reschedule : window.frenzyFetch.state.reschedule,
				},
				type : 'POST',
				success : function ( response ) {
					if ( 200 == response ) {
						window.frenzyFetchTimer = setInterval( function () {
							fetch_progress();
						}, 3500 );
					} else {
						clearInterval( window.frenzyFetchTimer );
						$( '#fetch-progress' ).remove();
						$( '.js-fetch-it' ).removeAttr( 'disabled' );
						alert( 'Something went wrong. Please try again later.' );
					}
				}
			} );

			// Reset the reschedule flag since we have now officially scheduled the post.
			window.frenzyFetch.resetRescheduleFlag();
		}

		function fetch_progress() {
			if ( $( '#fetch-progress' ).length == 0 ) {
				$( '#wpcontent' ).append( fetch_button );
			}

			// make api call to check status
			jQuery.ajax( {
				url : ajaxurl + '?action=fetch_get_status',
				data : {
					post_id : wp.media.view.settings.post.id
				},
				type : 'POST',
				success : function ( response ) {
					let widthTouse = response.data.progress;
					if ( 100 == widthTouse ) {
						widthTouse = 99;
					}


					// Prevent regression.
					let currentProgress = $( '#fetch-progress-container span' ).text().replace( '%', '' );
					if ( currentProgress > widthTouse ) {
						return;
					}

					$( '#fetch-progress-container span' ).text( widthTouse + '%' );
					$( '#fetch-progress-container' ).css( { 'width' : widthTouse + '%' } );

					// if status done clear the interval
					if ( 100 == response.data.progress ) {
						clearInterval( window.frenzyFetchTimer );
						window.frenzyFetch.state.reschedule = false;
						$( '#fetch-progress h2' ).append( window.frenzyFetch.$loadingSpinner );

						jQuery.ajax( {
							url : ajaxurl + '?action=fetch_parse_response',
							data : {
								post_id : wp.media.view.settings.post.id
							},
							type : 'POST',
							success : function ( response ) {
								if ( 0 < $( '#frenzy-shop-buttton-frame:visible' ).length ) {
									$( '#fetch-progress' ).remove();
									$( '.js-fetch-it' ).removeAttr( 'disabled' );
								}

								// Make sure we show full progress complete.
								$( '#fetch-progress-container span' ).text( 100 + '%' );
								$( '#fetch-progress-container' ).width( 100 + '%' );
								$( '#fetchprods' ).css( 'display', 'block' );
								refreshShopButtonFrame();
							}
						} );
					}
				}
			} );
		}

		if ( wp.media && wp.media.view && wp.media.view.settings && wp.media.view.settings.post && wp.media.view.settings.post.id ) {
			// Accepts an optional object hash to override default values.
			window.frenzyframe = new wp.media.view.MediaFrame.Select( {
				// Modal title
				title : 'Fetch',
				id : 'frenzy-shop-buttton-frame',
				multiple : false,
				menu : true,
				library : {
					order : 'ASC',
					orderby : 'title',
					frenzy : 'frenzy',
					type : 'image',
					search : null,
					uploadedTo : wp.media.view.settings.post.id
				},

				button : {
					text : 'Save'
				}
			} );

			window.frenzyframe.on( 'ready', function () {
				window.frenzyframe.views.set( '.media-frame-menu', new window.frenzyFetch.sidebar( { activeTab : 'shop-button' } ) );

				// Add our fetch it button.
				if ( 0 === $( '#frenzy-shop-buttton-frame .js-fetch-it' ).length ) {
					$( '#frenzy-shop-buttton-frame .media-frame-title' ).append(
						'<button class="fetch-button js-switch-to-manual-products fetch-secondary-button">' +
						'+ Add Products' +
						'</button>'
					);
					$( '#frenzy-shop-buttton-frame .media-frame-title' ).append(
						'<button class="fetch-button js-fetch-it fetch-it-button">' +
						'	<img src="' + frenzyWp.fetchLogoUrl + '" class="fetch-icon" /><img src="' + frenzyWp.fetchProductsTextUrl + '" alt="Fetch" class="fetch-products-image" /> products <span>beta</span>' +
						'</button>' +
						'<div class="fetch-help-tooltip">' +
						'<div class="fetch-tooltip-icon">?</div>' +
						'<div class="fetch-tooltip-teaser">Press the "Fetch Products" button to automatically match products.</div>' +
						'<div class="fetch-help-tooltip-content">' +
						'<div class="fetch-tooltip-arrow-up"></div>' +
						'<p>- "Fetch Products" automatically matches products in your images.</p>' +
						'<p>- "Add Products" lets you search and add from our catalog.</p>' +
						'<p>- Drag and drop items to rearrange order.</p>' +
						'</div>' +
						'</div>'
					);

					shop_button_checked = '';
					if ( frenzyPostSettings.showShopButton > 0 ) {
						shop_button_checked = ' checked ';
					}

					$( '#frenzy-shop-buttton-frame .media-frame-content .media-toolbar' ).append(
						'<div class="shop-toggle-wrapper">' +
						'<label for="frenzy-shop-toggle">Show Shop Button on Images</label>' +
						'<div class="checkbox-switch">' +
						'<input type="checkbox" ' +
						shop_button_checked +
						'value="1" name="frenzy-shop-toggle" class="input-checkbox js-toggle-shop-settings" id="frenzy-shop-toggle">' +
						'<div class="checkbox-animate">' +
						'<span class="checkbox-off">NO</span>' +
						'<span class="checkbox-on">YES</span>' +
						'</div>' +
						'</div>' +
						'</div>'
					);

					shop_price_checked = '';
					if ( frenzyPostSettings.showPrice > 0 ) {
						shop_price_checked = ' checked ';
					}
					
					$( '#frenzy-shop-buttton-frame .media-frame-content .media-toolbar' ).append(
						'<div class="shop-toggle-wrapper shop-toggle-price-wrapper">' +
						'<label for="frenzy-shop-price-toggle">Show Product Prices</label>' +
						'<div class="checkbox-switch">' +
						'<input type="checkbox" ' +
						shop_price_checked +
						'value="1" name="frenzy-shop-price-toggle" class="input-checkbox js-toggle-shop-settings" id="frenzy-shop-price-toggle">' +
						'<div class="checkbox-animate">' +
						'<span class="checkbox-off">NO</span>' +
						'<span class="checkbox-on">YES</span>' +
						'</div>' +
						'</div>' +
						'</div>'
					);
				}
			} );


			$( 'body' ).on( 'click', '.js-toggle-shop-settings', function () {

				if ( $( '#post_ID' ).length > 0 ) {
					var post_id = $( '#post_ID' ).val()
					var show_button_val = $( '#frenzy-shop-toggle' ).prop( 'checked' );
					var show_price_val = $( '#frenzy-shop-price-toggle' ).prop( 'checked' );
					
					$.ajax( {
						url : frenzyWp.ajaxUrl,
						method : 'POST',
						data : {
							action : 'fetch_save_shop_settings',
							post_id : post_id,
							shop_button_val : show_button_val ? 1 : 0,
							show_price_val : show_price_val ? 1 : 0
						},
					} )
				}
			} );


			// window.frenzyframe.on( 'open', refreshShopButtonFrame );

			window.frenzyframe.on( 'select', function () {
				frame.edit.open().trigger( 'refresh', {} );
			} );

			$( 'body' ).on( 'click', '.js-check-all', function () {
				$( '.fetch-show-on-checkbox' ).prop( 'checked', true );

				// Auto save.
				$( '.frenzy-force-save-attachment-details' ).click();
			} );

			$( 'body' ).on( 'click', '.js-uncheck-all', function () {
				$( '.fetch-show-on-checkbox' ).prop( 'checked', false );

				// Auto save.
				$( '.frenzy-force-save-attachment-details' ).click();
			} );

			window.frenzyframe.on( 'selection:toggle', function () {
				$( 'body' ).off( 'click',
					'.currently-adding-carousel .attachment-product,' +
					'#frenzy-shop-buttton-frame .attachment-product' );

				$( 'body' ).off( 'click',
					'.currently-adding-carousel .attachment-product,' +
					'#frenzy-shop-buttton-frame .attachment-product'
				);

				$( 'body' ).on( 'click', '#frenzy-shop-buttton-frame .attachment-product', function () {
					if ( $( this ).hasClass( 'disabled' ) ) {
						return;
					}

					$( '#frenzy-shop-buttton-frame .media-sidebar .attachment-details' ).remove();
				} );

				$( 'body' ).on( 'click',
					'.currently-adding-carousel .attachment-product,' +
					'#frenzy-shop-buttton-frame .attachment-product', function ( e ) {
						if ( $( this ).hasClass( 'disabled' ) ) {
							return;
						}

						var pid = $( this ).attr( 'data-term-id' );
						var sidebar_content =
							'<div class="attachment-details">' +
							'<h2>Fetch Product Details</h2>' +
							'<div class="attachment-info">' +
							'<div class="thumbnail thumbnail-product">' +
							'<img src="' + $( this ).attr( 'data-term-url' ) + '" draggable="false" alt="" />' +
							'</div>' +
							'<div class="details">' +
							'<div class="filename">' +
							$( this ).attr( 'data-term-title' ) +
							'</div>' +
							'<div class="uploaded"> Price: $' +
							$( this ).attr( 'data-term-price' ) +
							'</div>' +
							'<div class="uploaded">Brand: ' +
							$( this ).attr( 'data-term-brand' ) +
							'</div>' +
							'<div class="uploaded">Retailer: ' +
							$( this ).attr( 'data-term-retailer' ) +
							'</div>' +
							'<div class="uploaded"><a href="' + $( this ).attr( 'data-term-source' ) + '" target="_blank">Visit Product Page</a>' +
							'</div>' +
							'</div>' +
							'</div>' +
							'</div>';

						if ( $( this ).attr( 'data-user_commission' ) ) {
							sidebar_content += '<div class="commission-amount">Commission Amount: $' + $( this ).attr( 'data-user_commission' ) +
								'</div>';
						}

						sidebar_content += '<div class="filename"><strong>Description</strong></div>' +
							'<div class="uploaded">' +
							$( this ).attr( 'data-term-description' ) +
							'</div>' +
							'<h2 class="fetch-show-on-label">' +
							'Add To' +
							'<div class="auto-selection-options">' +
							'<button class="js-check-all">Check all</button>' +
							'<button class="js-uncheck-all">Uncheck All</button>' +
							'</div>' +
							'<div class="fetch-help-tooltip fetch-add-to-tooltip">' +
							'<div class="fetch-tooltip-icon">?</div>' +
							'<div class="fetch-help-tooltip-content">' +
							'<div class="fetch-tooltip-arrow-up"></div>' +
							'<p>- Select the images you want this product to show up on.</p>' +
							'</div>' +
							'</div>' +
							'</h2>' +
							'<div class="frenzy-show-on-image-holder"></div>' +
							'</div>';

						$( '#frenzy-shop-buttton-frame .media-sidebar .attachment-details' ).remove();
						$( '#frenzy-shop-buttton-frame .media-sidebar' ).html( sidebar_content );
						window.frenzyFetch.loadImagesInSidebarForProduct( pid );
					} );
			} );

			function getContentFromEditor() {
				return window.frenzyFetch.getContentFromEditor();
			}

			function getTitleFromEditor() {
				let title = '';
				if ( window.frenzyFetch.gutenberg.isGutenbergActive() ) {
					title = window.frenzyFetch.gutenberg.getEditorTitle();
				} else {
					title = $( 'input[name="post_title"]' ).val();
				}

				return title;
			}

			$( '#wpcontent' ).on( 'click', '.open-shop-frame', function ( event ) {
				event.preventDefault();
				let content = getContentFromEditor();
				let title = getTitleFromEditor();
				let postThumbnailId = $( '#_thumbnail_id' ).val();

				// Check for Gutenberg support.
				if ( 'undefined' === typeof postThumbnailId && window.frenzyFetch.gutenberg.isGutenbergActive() ) {
					postThumbnailId = window.frenzyFetch.gutenberg.getFeaturedImage();
				}

				// Check if the post content is different since the last time we opened the window.
				if ( window.frenzyFetch.getPostContent() !== content ) {
					window.frenzyFetch.state.reschedule = true;
				}

				if (
					(postThumbnailId) ||
					(window.location.href.indexOf( 'post-new.php' ) > 0 && '' !== content) ||
					true // Force this to go through. May revisit later.
				) {
					let postId = $( '#post_ID' ).val();
					$( '.open-shop-frame' ).attr( 'disabled', 'disabled' );
					$.ajax( {
						url : frenzyWp.ajaxUrl,
						method : 'POST',
						data : {
							action : 'fetch_save_draft_post_content',
							post_id : postId,
							post_thumbnail : postThumbnailId,
							post_content : content,
							post_title : title,
						},
					} ).done( function ( data ) {
						$( '.open-shop-frame' ).removeAttr( 'disabled' );

						if ( 0 === data.data.post_images.length ) {
							window.frenzyFetch.state.post_has_images = false;
						} else {
							window.frenzyFetch.state.post_has_images = true;
						}

						window.frenzyFetch.openShopFrame();
						refreshShopButtonFrame();
						window.frenzyFetch.productCarousel.resetCarouselTab();
					} );
				} else {
					window.frenzyFetch.openShopFrame();
					window.frenzyFetch.productCarousel.resetCarouselTab();
				}
			} );

			$( '#wpcontent' ).on( 'click', '.view-products-after-success', function () {
				$( '#fetch-progress' ).hide();
				$( '.js-fetch-it' ).removeAttr( 'disabled' );
			} );

			// This will replace the gallery-edit flow, we still need to write code for binding handlers between the states
			var fetchDetailsMediaFrame = wp.media.view.MediaFrame.Post.extend( {
				createStates : function createStates() {
					var options = this.options;
					this.states.add( [
						new wp.media.controller.Library( {
							id : 'product-gallery',
							title : 'Product Carousel',
							priority : 40,
							toolbar : 'gallery-add',
							filterable : 'all',
							multiple : 'add',
							menu : 'gallery',
							editable : false,
							displaySettings : true,
							displayUserSettings : true,
							mirroring : false,
							library : wp.media.query( _.defaults( {
								frenzyproducts : 'frenzyproducts',
								where : 'fetchDetailsMediaFrame',
								posts_per_page : 999,
								query : true,
								mirroring : false,
							}, options.library ) )
						} ),
						new wp.media.controller.GalleryEdit( {
							title : 'Customize Product Carousel',
							library : this.options.selection,
						} ),
					] );
				},
			} );


			wp.media.frenzy = {
				frame : new fetchDetailsMediaFrame( {
					state : 'product-gallery',
					id : 'fetch-product-carousel',
					frame : 'post',
					editing : true,
					multiple : true,
					displaySettings : true,
					displayUserSettings : true,
				} )
			};

			var attachments = wp.media.query( {
				order : 'ASC',
				posts_per_page : 10,
				query : true,
				type : 'image'
			} )
			var selection = new wp.media.model.Selection( attachments.models, {
				props : attachments.props.toJSON(),
				multiple : true
			} );

			// Ensure that the sidebar menu is visible on this screen.
			wp.media.frenzy.frame.states.get( 'gallery-edit' ).on( 'activate', function () {
				window.frenzyFetch.productCarousel.state.editHasBeenOpened = true;
				this.set( 'menu', 'gallery' );

				updateCarouselButtonText( 'Insert Product Carousel' );
				$( '#fetch-product-carousel' ).removeClass( 'currently-adding-carousel' );
				$( '#fetch-product-carousel' ).addClass( 'currently-editing-carousel' );
				$( '.currently-editing-carousel ul.attachments' ).sortable( 'enable' );

				$( '.currently-editing-carousel .attachments-browser .media-toolbar' )
					.append( '<button class="fetch-button fetch-secondary-button js-back-to-add-carousel-screen fetch-add-to-carousel-button">< Add More Products to Carousel</button>' );

				// Handle if we are in edit state and need to ensure that the carousel value is set correctly.
				if ( '' !== window.frenzyFetch.state.currentlyEditingCarousel && false === window.frenzyFetch.productCarousel.state.manuallyChanged ) {
					let shortcode = window.frenzyFetch.state.currentlyEditingCarousel;
					window.frenzyFetch.productCarousel.state.type = '';

					// need to chwck if different than shortcode
					if ( -1 !== shortcode.indexOf( 'type="columns-2"' ) ) {
						window.frenzyFetch.productCarousel.state.type = 'columns-2';
					}

					if ( -1 !== shortcode.indexOf( 'type="columns-3"' ) ) {
						window.frenzyFetch.productCarousel.state.type = 'columns-3';
					}

					if ( -1 !== shortcode.indexOf( 'type="columns-4"' ) ) {
						window.frenzyFetch.productCarousel.state.type = 'columns-4';
					}
				}

				resetCarouselSidebar();
			} );

			function resetCarouselSidebar() {
				$( '#fetch-product-carousel .gallery-settings' ).html( '' );
				$( '#fetch-product-carousel .gallery-settings' )
					.html( $( '#tmpl-product-carousel-settings' ).html() );

				$( '.collection-settings.gallery-settings .columns' ).val( window.frenzyFetch.productCarousel.state.type );
				window.frenzyFetch.addListenerForCarouselType();
			}

			// Make sure we add the buttons when we swap states from the edit page.
			wp.media.frenzy.frame.states.get( 'product-gallery' ).on( 'activate', function () {
				addFetchButtonsToCarouselAdminModal();
				$( '#fetch-product-carousel' ).removeClass( 'currently-editing-carousel' );
				$( '#fetch-product-carousel' ).addClass( 'currently-adding-carousel' );
			} );

			wp.media.frenzy.frame.on( 'ready', function () {
				wp.media.frenzy.frame.views.set( '.media-frame-menu', new window.frenzyFetch.sidebar( { activeTab : 'product-carousel' } ) );
				addFetchButtonsToCarouselAdminModal();
			} );

			wp.media.frenzy.frame.on( 'selection:toggle', function ( e ) {
				updateCarouselButtonText( 'Create Product Carousel' );
			} );

			$( 'body' ).on( 'click', '#fetch-product-carousel .attachment', function () {
				window.frenzyFetch.loadImagesInSidebarForProduct( $( this ).attr( 'data-id' ) );
			} );

			function addFetchButtonsToCarouselAdminModal() {
				updateCarouselButtonText( 'Create Product Carousel' );

				if ( 0 === $( '#fetch-product-carousel .js-fetch-it' ).length ) {
					$( '#fetch-product-carousel .media-frame-title' )
						.append(
							'<button class="fetch-button js-switch-to-manual-products fetch-secondary-button">' +
							'	+ Add Products' +
							'</button>'
						);
					$( '#fetch-product-carousel .media-frame-title' )
						.append(
							'<button class="fetch-button js-fetch-it fetch-it-button">' +
							'	<img src="' + frenzyWp.fetchLogoUrl + '" class="fetch-icon" /><img src="' + frenzyWp.fetchProductsTextUrl + '" alt="Fetch" class="fetch-products-image" /> products <span>beta</span>' +
							'</button>' +
							'<div class="fetch-help-tooltip">' +
							'<div class="fetch-tooltip-icon">?</div>' +
							'<div class="fetch-tooltip-teaser">Select which products you would like to include, then click "Create Product Carousel".</div>' +
							'<div class="fetch-help-tooltip-content">' +
							'<div class="fetch-tooltip-arrow-up"></div>' +
							'<p>- The products on this page have either been matched by Fetch or added by you.</p>' +
							'<p>- Select which products you would like to include in your product carousel, then click "Create Product Carousel".</p>' +
							'<p>- Press the "Fetch Products" button to automatically find products in your post.</p>' +
							'<p>- Click "Add Products" to search for more items.</p>' +
							'</div>' +
							'</div>' +
							'</div>'
						);
				}
			}

			// TinyMCE version.
			wp.media.frenzy.frame.on( 'update', function () {
				var controller = wp.media.frenzy.frame.states.get( 'gallery-edit' );

				var library    = controller.get( 'library' );
				var columns    = controller.get( 'columns' );

				atts = '';
				
				if ( columns ) {
					atts = ' type="' + columns + '"';
				}
				
				// Need to get all the attachment ids for gallery
				let ids = library.pluck( 'id' );

				// Handle what to do with Gutenberg.
				if ( window.frenzyFetch.gutenberg.isGutenbergActive() ) {
					let attributes = {
						type : columns,
						ids : ids.toString()
					};

					if ( false === window.frenzyFetch.gutenberg.state.current ) {
						let block = wp.blocks.createBlock( 'fetch/product-carousel', attributes );
						wp.data.dispatch( 'core/editor' ).insertBlocks( block );
					} else {
						wp.data.dispatch( 'core/editor' )
							.updateBlockAttributes( window.frenzyFetch.gutenberg.state.current.clientId, attributes );

						// Reset back to false since we're done editing this block.
						window.frenzyFetch.gutenberg.state.current = false;
					}

					return;
				}

				html = '[fetch ids="' + ids.toString() + '"' + atts + ']';

				var editor, wpActiveEditor,
					hasTinymce = !_.isUndefined( window.tinymce ),
					hasQuicktags = !_.isUndefined( window.QTags );

				if ( this.activeEditor ) {
					wpActiveEditor = window.wpActiveEditor = this.activeEditor;
				} else {
					wpActiveEditor = window.wpActiveEditor;
				}


				if ( !wpActiveEditor ) {
					if ( hasTinymce && tinymce.activeEditor ) {
						editor = tinymce.activeEditor;
						wpActiveEditor = window.wpActiveEditor = editor.id;
					} else if ( !hasQuicktags ) {
						return false;
					}
				} else if ( hasTinymce ) {
					editor = tinymce.get( wpActiveEditor );
				}

				// Handle if we are updating an existing shortcode.
				if ( '' !== window.frenzyFetch.state.currentlyEditingCarousel ) {
					let content = tinyMCE.activeEditor.getContent();
					content = content.replace( window.frenzyFetch.state.currentlyEditingCarousel, html );
					tinyMCE.activeEditor.setContent( content );
					tinyMCE.activeEditor.execCommand( 'mceRepaint' );
					window.frenzyFetch.state.currentlyEditingCarousel = '';
					window.frenzyFetch.productCarousel.state.type = '';
				} else {
					if ( editor && !editor.isHidden() ) {
						editor.execCommand( 'mceInsertContent', false, html );
					} else if ( hasQuicktags ) {
						QTags.insertContent( html );
					} else {
						document.getElementById( wpActiveEditor ).value += html;
					}
				}

				controller.off( 'reset' );
			} );
		}
	} );

	$( document ).ready( function () {
	} );
})( jQuery );

(function ( $ ) {
	'use strict';

	/**
	 * If the reset button isn't present, don't worry about clearing out the settings screen. This
	 * is only used on the 'Settings' page.
	 *
	 * @private
	 */
	var _initSettings = function () {

		var $frenzyResetSettings = $( '#frenzy-reset-settings' );

		if ( 0 === $frenzyResetSettings.length ) {
			return;
		}

		$frenzyResetSettings
			.on( 'click', function ( evt ) {
				evt.preventDefault();
				$( 'input[type="text"]' ).val( '' );
			} );
	};

	/**
	 * Determines if the specified element is checked or not. This expects an HTML input element that supports the
	 * :checked pseudo-selector.
	 *
	 * @param   $elem The input element to examine.
	 * @returns bool  True if the element is checked; false, otherwise.
	 * @private
	 */
	var _isChecked = function ( $elem ) {
		return $elem.is( ':checked' );
	};

	/**
	 * Disables and un-checks the specified element by adding the `disabled` attribute.
	 *
	 * @param   $elem The input element to disable.
	 * @private
	 */
	var _disable = function ( $elem ) {
		$elem
			.attr( 'disabled', true )
			.attr( 'checked', false );
	};

	/**
	 * Disables the specified element by removing the `disabled` attribute.
	 *
	 * @param   $elem The input element to enable.
	 * @private
	 */
	var _enable = function ( $elem ) {
		if ( 'disabled' === $elem.attr( 'disabled' ) ) {
			$elem.removeAttr( 'disabled' );
			$( '#frenzy-position-top' ).prop( 'checked', 'checked' );
			$( '#frenzy-position-left' ).prop( 'checked', 'checked' );
		}
	};

	/**
	 * Toggles the specified element based on the value of the specified trigger. If the trigger is
	 * checked, then the element(s) will be enabled. Otherwise, they will be disabled.
	 *
	 * @param $trigger The element that controls if the $elem is enabled or not.
	 * @param $elem    The element(s) to disable and/or clear when the trigger is checked.
	 * @private
	 */
	var _toggle = function ( $trigger, $elem ) {

		if ( _isChecked( $trigger ) ) {
			_enable( $elem );
			return;
		}

		_disable( $elem );
	};

	/**
	 * Initializes the event handlers for the post meta box.
	 * @private
	 */
	var _initMetaBox = function () {

		var $enableFrenzy = $( 'input[name="frenzy-enabled"]' ),
			$frenzyPosition = $( 'input[name="frenzy-position"]' ),
			$frenzyPositionHorizontal = $( 'input[name="frenzy-position-horizontal"]' );

		_toggle( $enableFrenzy, $frenzyPosition );
		_toggle( $enableFrenzy, $frenzyPositionHorizontal );
		$enableFrenzy.on( 'click', function () {
			_toggle( $( this ), $frenzyPosition );
			_toggle( $( this ), $frenzyPositionHorizontal );
		} );
	};

	/**
	 * NOTE: Add this in during version 2.0 or when the endpoint is ready. Note to alter the endpoint
	 * on the front-end.
	 *
	 * Sends the information about this post to the Frenzy API for use when crawling the site.
	 *
	 * @private
	 */
	var _notifyFrenzy = function ( e ) {
		e.preventDefault();

		var endpoint = $( 'input[name="frenzy-post-info-endpoint"]' ).val(),
			username = $( 'input[name="frenzy-username"]' ).val(),
			apikey = $( 'input[name="frenzy-apikey"]' ).val(),
			permalink = $( 'input[name="frenzy-post-permalink"]' ).val(),
			postId = $( 'input[name="frenzy-post-id"]' ).val(),
			postStatus = $( 'input[name="frenzy-post-status"]' ).val(),
			$el = $( this );

		$el.prop( 'disabled', 'enabled' );

		if ( 'publish' !== postStatus && ('' === username || '' === apikey || '' === permalink) ) {
			return;
		}

		$.post( frenzyWp.ajaxUrl, {
			url : permalink,
			postId : postId,
			action : 'frenzy_force_update'
		}, function ( data, status ) {
			$el.prop( 'disabled', false );

			if ( 'success' === status ) {
				window.alert( 'This post is scheduled for being updated by Frenzy.' );
			} else {
				window.alert( 'There was an issue updating this post with Frenzy. Please try again later.' );
			}
		} );
	};

	var fetchAccountSettings = {
		init : function () {
			this.handleFormSwapping();
			$( '.fetch-ajax' ).submit( this.handleAjaxSubmit.bind( this ) );
			$( '.fetch-edit-account' ).submit( this.handleEditAccountSubmit.bind( this ) );
		},

		handleFormSwapping : function () {
			var $loginForm = $( '.fetch-login' ),
				$newAccountForm = $( '.fetch-new-account' ),
				$resetPwForm = $( '.fetch-reset-password' ),
				$forgotPwForm = $( '.fetch-forgot-password' );

			$( '.js-show-create-account' ).click( function ( event ) {
				event.preventDefault();
				$loginForm.hide();
				$resetPwForm.hide();
				$newAccountForm.show();
			} );

			$( '.js-show-login-field' ).click( function ( event ) {
				event.preventDefault();
				$loginForm.show();
				$newAccountForm.hide();
				$resetPwForm.hide();
				$forgotPwForm.hide();
			} );

			$( '.js-show-forgot-password' ).click( function ( event ) {
				event.preventDefault();
				$loginForm.hide();
				$resetPwForm.hide();
				$forgotPwForm.show();
			} );
		},

		handleAjaxSubmit : function ( event ) {
			event.preventDefault();

			var $form = $( event.target ),
				data = $form.serializeArray(),
				action = $form.attr( 'action' ),
				self = this;

			data.push( { name : 'action', value : 'fetch_' + action } );

			// Add the loading spinner.
			$form.find( 'h2' ).append( '<div class="fetch-loading-spinner lds-ring"><div></div><div></div><div></div><div></div></div>' );

			$.ajax( {
				url : frenzyWp.ajaxUrl,
				method : 'POST',
				data : data,
			} ).done( function ( response ) {
				$form.find( '.fetch-loading-spinner' ).remove();

				if ( response.success && response.data.redirect_to ) {
					location.reload();
				}

				if ( true == response.success ) {
					$( '.fetch-modal-container' ).fadeOut();
					$( '.js-' + action + '-successful-modal' ).fadeIn();
				} else {
					self.showFormAjaxError( response.data.message );
				}
			} );
		},

		handleEditAccountSubmit : function ( event ) {
			event.preventDefault();

			if ( $( '#new_password' ).val() !== $( '#confirm_new_password' ).val() ) {
				this.showFormAjaxError( 'Your new password confirmation does not match.' );
				return;
			}

			var $form = $( event.target ),
				data = $form.serializeArray(),
				action = $form.attr( 'action' ),
				self = this;
			data.push( { name : 'action', value : 'fetch_' + action } );

			// Add the loading spinner.
			$form.find( 'h2' ).append( '<div class="fetch-loading-spinner lds-ring"><div></div><div></div><div></div><div></div></div>' );

			$.ajax( {
				url : frenzyWp.ajaxUrl,
				method : 'POST',
				data : data,
			} ).done( function ( response ) {
				$form.find( '.fetch-loading-spinner' ).remove();

				if ( response.success ) {
					self.showFormAjaxSuccess( 'Your account was successfully updated.' );
				} else {
					self.showFormAjaxError( response.data.message );
				}
			} );
		},

		showFormAjaxMessage( type, message ) {
			var $container = $( '.fetch-ajax-' + type + '-container' );
			$( '.fetch-ajax-container' ).hide();
			$container.find( '.message' ).text( message );
			$container.show();
		},

		showFormAjaxError : function ( message ) {
			this.showFormAjaxMessage( 'error', message );
		},

		showFormAjaxSuccess : function ( message ) {
			this.showFormAjaxMessage( 'success', message );
		}
	};

	/**
	 * The bootstrap function that registers the events.
	 */
	$( function () {
		_initMetaBox();
		_initSettings();
		$( '.js-update-products' ).on( 'click', _notifyFrenzy );
		fetchAccountSettings.init();
	} );
})( jQuery );

/* global tinyMCE */
(function ( $ ) {
	$( document ).ready( function () {
		if ( wp.media && wp.media.view && wp.media.view.settings && wp.media.view.settings.post && wp.media.view.settings.post.id ) {
			var media = wp.media, shortcode_string = 'fetch';
			wp.mce = wp.mce || {};
			wp.mce.fetch = {
				shortcode_data : {},
				template : media.template( 'editor-fetch-banner' ),
				getContent : function () {
					var options = this.shortcode.attrs.named;
					var template = this.template;

					jQuery.ajax( {
						url : ajaxurl + '?action=fetch-get-preview-data',
						//action: 'fetch-get-preview-data',
						data : { ids : options.ids },
						type : 'POST',
						async : false,
						success : function ( response ) {
							options.products = response;
						}
					} );
					return template( options );
				},
				View : { // before WP 4.2:
					template : media.template( 'editor-fetch-banner' ),
					postID : $( '#post_ID' ).val(),
					initialize : function ( options ) {
						this.shortcode = options.shortcode;
						wp.mce.fetch.shortcode_data = this.shortcode;
					},
					getHtml : function () {
						var options = this.shortcode.attrs.named;
						options.innercontent = this.shortcode.content;
						return this.template( options );
					}
				},
				edit : function ( shortcode ) {
					if ( '1' !== window.frenzyWpSortable.isFetchLoggedIn ) {
						window.alert( 'You must log in to Fetch to add products.' );
						return;
					}

					var shortcode_data = wp.shortcode.next( shortcode_string, shortcode );
					var values = shortcode_data.shortcode.attrs.named;
					window.frenzyFetch.state.currentlyEditingCarousel = shortcode;
					window.frenzyFetch.openEditProductCarousel( values );
				}
			};
			wp.mce.views.register( shortcode_string, wp.mce.fetch );
		}
	} );
}( jQuery ));

/**
 * Fetch Settings page enhancements
 */
( function( $ ) {
	$( document ).ready( function ( $ ) {
		/**
		 * Initialize DataTables on the Analytics page
		 */
		$( '.fetch-commissions' ).DataTable( {
			paging: true,
			responsive: {
				details: {
					type: 'column'
				}
			}
		} );

		/**
		 * Used to convert the Subscriber's payout request from PHPs timestamp to a human readable time to display the payout requests on the PayPal settings page.
		 *
		 * Copy pasta to convert unix timestamps to JS dates
		 *
		 * @link https://stackoverflow.com/a/6078873
		 *
		 * @param int UNIX_timestamp Unix timestamp to convert to a JS time and date
		 * @returns string Human readable time
		 */
		function timeConverter(){

			$( '*[data-timestamp]' ).each( function( index, element ) {
				var $this = $( this );
				var timestamp = $this.data( 'timestamp' );

				if ( $.data( this, 'timestamp' ) && $.isNumeric( timestamp ) ) {
					var a = new Date(timestamp * 1000);
					var months = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
					var year = a.getFullYear();
					var month = months[a.getMonth()];
					var date = a.getDate();
					var hour = a.getHours();
					var ampm = hour >= 12 ? 'pm' : 'am';
					hour = hour % 12;
					var min = a.getMinutes() < 10 ? '0' + a.getMinutes() : a.getMinutes(); var sec = a.getSeconds() < 10 ? '0' + a.getSeconds() : a.getSeconds();
					var sec = a.getSeconds();
					var time = date + ' ' + month + ' ' + year + ' ' + hour + ':' + min + ' ' + ampm;

					$this.text(time);
				}
			} );

		}
		timeConverter();
	} );

} )( jQuery );
