( function( blocks, element ) {
	const { registerBlockType } = blocks; //Blocks API
	const { createElement } = element; //React.createElement
	const { __ } = wp.i18n; //translation functions
	const { InspectorControls } = wp.editor; //Block inspector wrapper
	const { TextControl, SelectControl, ServerSideRender } = wp.components; //WordPress form inputs and server-side renderer

	registerBlockType( 'fetch/product-carousel', {
		title : __( 'Product Carousel' ),
		category : __( 'widgets' ),
		attributes : {
			ids : {
				default : '',
			},
			type : {
				default : 'carousel'
			},
		},

		edit( props ) {
			const attributes = props.attributes;

			//Display block preview and UI
			return createElement( 'div', {
				onClick : function ( event ) {
					if ( '1' !== window.frenzyWpSortable.isFetchLoggedIn ) {
						window.alert( 'You must log in to Fetch to add products.' );
						return;
					}

					event.preventDefault();
					window.frenzyFetch.gutenberg.state.current = props;

					if ( '' === attributes.ids ) {
						window.frenzyFetch.openProductCarousel();
					} else {
						window.frenzyFetch.openEditProductCarousel( attributes );
					}
				}
			}, [
				createElement( ServerSideRender, {
					block : 'fetch/product-carousel',
					attributes : attributes
				} )
			] )
		},
		save() {
			return null;//save has to exist. This all we need
		}
	} );
}(
    window.wp.blocks,
    window.wp.element
) );