<?php
/**
 * @category  Bootstrap
 * @package   Fetch
 * @author    TODO <todo@todo.com>
 * @copyright 2019 Frenzy
 * @license   http://www.gnu.org/licenses/gpl-3.0.txt GPL-3.0+
 * @link      https://joinfetch.co
 *
 * @wordpress-plugin
 * Plugin Name:       Fetch
 * Plugin URI:        https://joinfetch.co
 * Description:       Fetch automatically finds, matches, and tags brand-specific products in your images.
 * Version:           3.6.0
 * Author:            frenzylabs
 * Author URI:        https://frenzy.ai/
 * License:           GPL-3.0+
 * License URI:       http://www.gnu.org/licenses/gpl-3.0.txt
 */

namespace Frenzy;

define( 'FRENZY_ASSETS_URL', plugin_dir_url( __FILE__ ) );

register_activation_hook( __FILE__, __NAMESPACE__ . '\\frenzy_activate' );
/**
 * Verifies that the user is running the proper version of WordPress for the
 * plugin to execute; otherwise, displays an error message and prevents the
 * plugin from being activated.
 */
function frenzy_activate() {
	if ( version_compare( PHP_VERSION, '5.4.45', '<' ) ) {
		wp_die(
			sprintf(
				'Frenzy for WordPress requires PHP 5.4.45 or higher.
                Your WordPress site is using PHP %s. Please contact your hosting
                provider and ask that they upgrade the version of PHP on which
                your installation of WordPress is running. Click back in your
                browser to your WordPress dashboard.',
				PHP_VERSION
			)
		);
	}
}

require file_exists( $composer = __DIR__ . '/vendor/autoload.php' ) ? $composer : __DIR__ . '/dist/autoload.php';

add_action( 'plugins_loaded', __NAMESPACE__ . '\\frenzyStart', 99 );
/**
 * Starts the plugin.
 *
 * @return void
 */
function frenzyStart() {
	$plugin = new Plugin( __FILE__ );
	$plugin->load();
}
