<?php

namespace Frenzy\Inc;

class FetchGutenberg {
	public function init() {
		add_action( 'init', [ $this, 'product_carousel_block_init' ] );
	}

	function product_carousel_block_init() {
		if ( ! function_exists( 'register_block_type' ) ) {
			return;
		}

		$dir      = dirname( dirname( __FILE__ ) );
		$index_js = 'assets/scripts/dev/fetch-product-carousel.js';
		wp_register_script(
			'fetch-product-carousel-block-editor',
			plugins_url( $index_js, $dir ),
			array(
				'wp-blocks',
				'wp-i18n',
				'wp-element',
				'wp-editor',
				'wp-components',
			),
			time()
		);

		$fetchShortcode = new FetchShortcode();
		register_block_type(
			'fetch/product-carousel',
			array(
				'editor_script'   => 'fetch-product-carousel-block-editor',
				'attributes'      => array(
					'ids'  => array( 'type' => 'string' ),
					'type' => array( 'type' => 'string' ),
				),
				'render_callback' => [ $fetchShortcode, 'fetch_product_carousel' ],
			)
		);
	}
}
