<?php

namespace Frenzy\PluginAPI;

/**
 * HookSubscriberInterface
 *
 * @since     1.0.0
 * @package   Frenzy\PluginAPI
 * @author    TODO
 */
interface HookSubscriberInterface {

	/**
	 * Returns an array of hooks to which an object subscribes.
	 *
	 * The array key is the name of the hook. The value can be:
	 *
	 *  - the method name
	 *  - an array with the method name and priority
	 *  - an array with the method name, priority and number of accepted arguments
	 *
	 * For instance:
	 *
	 *  - [ 'hook_name' => 'method_name' ]
	 *  - [ 'hook_name' => [ 'method_name', $priority ] ]
	 *  - [ 'hook_name' => [ 'method_name', $priority, $accepted_args ] ]
	 *
	 * @return array
	 */
	public static function getHooks();
}
