<?php
/**
 * Renders the settings for the meta box on the post admin screen.
 */
?>
<style>
	.fetch-accounts-container * {
		box-sizing: border-box;
	}
	.fetch-accounts-container {
		padding-top: 100px;
		max-width: 400px;
		margin: 0 auto;
	}

	.fetch-accounts-container label {
		font-weight: bold;
		display: inline-block;
	}

	.fetch-accounts-container input {
		width: 100%;
		padding: 10px;
	}

	.fetch-accounts-container input[type='checkbox'] {
		width: 15px;
	}

	.fetch-accounts-container .form-row {
		margin-bottom: 10px;
	}

	.fetch-accounts-container .contains-help-link label {
		width: 30%;
	}

	.fetch-accounts-container .contains-help-link a {
		display: inline-block;
		width: 70%;
		text-align: right;
		font-weight: normal;
	}

	.fetch-modal-background {
		position: fixed;
		width: 100%;
		height: 100%;
		top: 0;
		left: 0;
		background: rgba(0,0,0,0.6);
	}

	.fetch-inner-modal {
		position: absolute;
		top: 40%;
		left: 30%;
		background: #eee;
		padding: 40px;
		margin: 0 auto;
	}

	.fetch-inner-modal h2 {
		margin-top: 0;
	}

	.fetch-ajax-container {
		border: 1px solid black;
		padding: 0 15px;
		display: none;
	}

	.fetch-ajax-error-container {
		border-color: #f5c6cb;
		background: #f8d7da;
		color: #721c24;
	}

	.fetch-ajax-success-container {
		border-color: #c3e6cb;
		background: #d4edda;
		color: #155724;
	}

	.fetch-analytics-box {
		width: 26%;
		margin-right: 1%;
		display: inline-block;
		background: #F79C6C;
		padding: 20px;
		text-align: center;
		color: white;
	}

	.fetch-analytics-box h2 {
		color: white;
	 }
</style>
<div class="wrap">
	<?php
	$active_tab = 'accounts';
	if ( ! empty( $_GET['tab'] ) ) {
		$active_tab = esc_html( $_GET['tab'] );
	}

	if ( ! \Frenzy\Helpers\HelperFunctions::is_fetch_logged_in() ) {
		$active_tab = 'accounts';
	}
	?>
	<h2 class="nav-tab-wrapper">
		<a href="?page=fetch-settings-submenu&tab=analytics" class="nav-tab <?php echo $active_tab == 'analytics' ? 'nav-tab-active' : ''; ?>">Analytics</a>
		<a href="?page=fetch-settings-submenu&tab=accounts" class="nav-tab <?php echo $active_tab == 'accounts' ? 'nav-tab-active' : ''; ?>">Account</a>
		<a href="?page=fetch-settings-submenu&tab=paypal" class="nav-tab <?php echo $active_tab == 'paypal' ? 'nav-tab-active' : ''; ?>">PayPal</a>
		<a href="?page=fetch-settings-submenu&tab=settings" class="nav-tab <?php echo $active_tab == 'settings' ? 'nav-tab-active' : ''; ?>">Settings</a>
	</h2>

	<?php
	switch ( $active_tab ) {
		case 'accounts':
			include __DIR__ . '/settings/account.php';
			break;
		case 'analytics':
			include __DIR__ . '/settings/analytics.php';
			break;
		case 'paypal':
			include __DIR__ . '/settings/paypal.php';
			break;
		case 'settings':
		default:
			include __DIR__ . '/settings/settings.php';
			break;
	}
	?>
</div><!-- .wrap -->
