<div class="fetch-modal-container js-create_account-successful-modal" style="display: none;">
	<div class="fetch-modal-background"></div>
	<div class="fetch-inner-modal">
		<h2>Congratulations and welcome to the Fetch community!</h2>
		<p>We'd love to show you how to use the plugin.</p>
		<a href="http://joinfetch.co/getting-started-with-fetch/" class="button-primary" target="_blank">Teach me how to use the plugin</a>
		<a href="?page=fetch-settings-submenu&tab=accounts" class="button-secondary">I know how to use it</a>
	</div>
</div>

<div class="fetch-accounts-container">
	<div class="fetch-ajax-notices">
		<div class="fetch-ajax-container fetch-ajax-error-container">
			<p class="message"></p>
		</div>
		<div class="fetch-ajax-container fetch-ajax-success-container">
			<p class="message"></p>
		</div>
	</div>

	<?php if ( \Frenzy\Helpers\HelperFunctions::is_fetch_logged_in() ) :
		$account_info = \Frenzy\Helpers\HelperFunctions::get_logged_in_fetch_account_info(); ?>
		<form class="fetch-edit-account" action="edit_account">
			<h2>Edit Account</h2>
			<p><a href="<?php echo esc_url( admin_url( '?fetch-logout-account' ) ); ?>">Logout of this Fetch Account</a></p>
			<div class="form-row">
				<label for="name">Name</label>
				<input type="text" name="name" id="name" value="<?php echo esc_attr( $account_info['name'] ); ?>" required>
			</div>
			<div class="form-row">
				<label for="email-address">Email Address</label>
				<input type="email" name="email-address" id="email-address" value="<?php echo esc_attr( $account_info['email'] ); ?>" required>
			</div>
			<div class="form-row">
				<label for="current_password">Current Password</label>
				<input type="password" name="current_password" id="current_password" required>
			</div>
			<div class="form-row">
				<label for="new_password">New Password</label>
				<input type="password" name="new_password" id="new_password">
			</div>
			<div class="form-row">
				<label for="confirm_new_password">Confirm New Password</label>
				<input type="password" name="confirm_new_password" id="confirm_new_password">
			</div>
			<div class="form-row">
				<input type="submit" value="Update Account Info" class="button-primary">
			</div>
		</form>
	<?php else : ?>
		<form class="fetch-ajax fetch-new-account" style="<?php echo ( empty( $_GET['reset-token'] ) ) ? '' : 'display: none;'; ?>" action="create_account">
			<h2>Create a Fetch Account</h2>
			<div class="form-row">
				<div class="contains-help-link">
					<label for="invite-code">Invite Code</label><!--
				--><a href="https://www.joinfetch.co/needinvite" target="_blank">Don't have an invite code?</a>
				</div>
				<input type="text" name="invite-code" id="invite-code" required>
			</div>
			<div class="form-row">
				<label for="name">Name</label>
				<input type="text" name="name" id="name" required>
			</div>
			<div class="form-row">
				<label for="email-address">Email Address</label>
				<input type="email" name="email-address" id="email-address" required>
			</div>
			<div class="form-row">
				<label for="password">Password</label>
				<input type="password" name="password" id="password" required>
			</div>
			<div class="form-row">
				<input type="checkbox" name="terms" id="terms-and-conditions" required>
				<label for="terms-and-conditions">I agree to the <a href="http://joinfetch.co/terms-and-conditions/" target="_blank">terms and conditions</a>.</label>
			</div>
			<div class="form-row">
				<input type="submit" value="Sign Up" class="button-primary">
			</div>

			<a href="#" class="js-show-login-field">Login to my Fetch Account</a>
		</form>

		<form class="fetch-ajax fetch-login" style="display: none;" action="login">
			<h2>Login</h2>
			<div class="form-row">
				<label for="email-address">Email Address</label>
				<input type="email" name="email-address" id="email-address" required>
			</div>
			<div class="form-row">
				<div class="contains-help-link">
					<label for="password">Password</label><!--
				--><a href="#" class="js-show-forgot-password">Forgot password?</a>
				</div>
				<input type="password" name="password" id="password" required>
			</div>
			<div class="form-row">
				<input type="submit" value="Login" class="button-primary">
			</div>
			<a href="#" class="js-show-create-account">Create a Fetch Account</a>
		</form>

		<form class="fetch-ajax fetch-forgot-password" style="display: none;" action="forgot_password">
			<h2>Forgot Password</h2>
			<div class="form-row">
				<label for="email-address">Email Address</label>
				<input type="email" name="email-address" id="email-address">
			</div>
			<div class="form-row">
				<input type="submit" value="Login" class="button-primary">
			</div>
			<a href="#" class="js-show-login-field">Login to my Fetch Account</a>
		</form>

		<form class="fetch-ajax fetch-reset-password" style="<?php echo ( ! empty( $_GET['reset-token'] ) ) ? '' : 'display: none;'; ?>" action="reset_password">
			<h2>Reset Your Password</h2>
			<div class="form-row">
				<label for="email">Email</label>
				<input type="email" name="email" id="reset-email">
			</div>
			<div class="form-row">
				<label for="password">New Password</label>
				<input type="password" name="password" id="new-password">
				<input type="hidden" name="token" value="<?php echo esc_attr( $_GET['reset-token'] ); ?>">
			</div>
			<div class="form-row">
				<input type="submit" value="Submit" class="button-primary">
			</div>

			<a href="#" class="js-show-login-field">Login</a>
		</form>
	<?php endif; ?>
</div>
