<h2>Analytics</h2>
<?php
$indi        = new \Frenzy\API\Indi();
$commission = $indi->getCommissionDetails();
?>
<div class="fetch-analytics-box">
	<h2><?php echo esc_html( $indi->getPending() ); ?></h2>
	<p>Pending</p>
</div><!--
--><div class="fetch-analytics-box">
	<h2><?php echo esc_html( $indi->getPayable() ); ?></h2>
	<p>Earned</p>
</div><!--
--><div class="fetch-analytics-box">
	<h2><?php echo esc_html( $indi->getPaid() ); ?></h2>
	<p>Paid</p>
</div>

<?php if ( ! empty( $commission ) ) : ?>
<h2>Your Earned Commissions</h2>
<table class="widefat fetch-table fetch-commissions">
    <thead>
        <tr>
            <th class="row-title">Order ID</th>
            <th class="row-title">Order Date</th>
            <th class="row-title">Product Name</th>
            <th class="row-title">Merchant Name</th>
            <th class="row-title">Sales Amount</th>
            <th class="row-title">Commission</th>
        </tr>
    </thead>
    <tbody>
        <?php foreach ( $commission as $detail ) :
            // Remove the 'Order' string from the sales date and keep only the numbers, which is a timestamp in milliseconds
            $order_date_milliseconds = preg_replace( '~\D~', '', $detail->OrderDate );
            if ( is_numeric( $order_date_milliseconds ) ) {
                $detail->OrderDate = date( 'm/d/Y', $order_date_milliseconds / 1000 );
            }
        ?>
        <tr>
            <td class="commission-order-id"><?php esc_html_e( $detail->OrderId ); ?></td>
            <td class="commission-date"><?php esc_html_e( $detail->OrderDate ); ?></td>
            <td class="commission-product"><?php esc_html_e( $detail->ProductName ); ?></td>
            <td class="commission-merchant"><?php esc_html_e( $detail->MerchantName ); ?></td>
            <td class="commission-sales-amount">$<?php echo number_format( esc_html__( $detail->SaleAmount ), 2 ); ?></td>
            <td class="commission-earned">$<?php echo number_format( esc_html__( $detail->Commission ), 2 ); ?></td>
        </tr>
        <?php endforeach; ?>
    </tbody>
</table>
<?php endif; ?>
