<?php require_once __DIR__ . '/../templates/settings-message.php'; ?>
<style>
	.settings-column {
		width: 49%;
		display: inline-block;
		vertical-align: top;
	}
</style>
<form method="post" action="<?php echo esc_html( admin_url( 'admin-post.php' ) ); ?>">
	<div id="" class="settings-column">
		<h2 class="wp-heading-inline">Shop Button Location on Your Photos</h2>
		<div id="frenzy-options-container">
			<div class="option">
				<p class="description">Where should the 'Shop' badge appear on the image?</p>
				<p class="description">Note: To avoid overlaps, place your shop button in a different corner than Pinterest and other similar buttons.</p>
				<label for="fetch-position-vertical">
					<input type="radio" id="fetch-position-vertical" name="fetch-position-vertical" value="top" 
					<?php
					checked(
						\Frenzy\Helpers\HelperFunctions::get_shop_button_vertical_location(),
						'top',
						true
					);
					?>
					/>
					At the top
				</label>
				<label for="fetch-position-vertical">
					<input type="radio" id="fetch-position-vertical" name="fetch-position-vertical" value="bottom"
						<?php
						checked(
							\Frenzy\Helpers\HelperFunctions::get_shop_button_vertical_location(),
							'bottom',
							true
						);
						?>
					/>
					At the bottom
				</label>
			</div><!-- .option -->
			<div class="option">
				<label for="fetch-position-left">
					<input type="radio" id="fetch-position-left" name="fetch-position-horizontal" value="left" 
					<?php
					checked(
						\Frenzy\Helpers\HelperFunctions::get_shop_button_horizontal_location(),
						'left',
						true
					);
					?>
					/>
					At the left
				</label>
				<label for="fetch-position-right">
					<input type="radio" id="fetch-position-right" name="fetch-position-horizontal" value="right" 
					<?php
					checked(
						\Frenzy\Helpers\HelperFunctions::get_shop_button_horizontal_location(),
						'right',
						true
					);
					?>
					/>
					At the right
				</label>
			</div><!-- .option -->

			<div class="option">
				<h2 class="wp-heading-inline">Shop Button Appears</h2>
				<?php $fetch_shop_btn_show_always = \Frenzy\Helpers\HelperFunctions::get_frenzy_shop_hover_or_always(); ?>
				<div>
					<label for="fetch-shop-btn-show-always">
						<input type="radio" id="fetch-shop-btn-show-always" name="fetch-shop-btn-show-always" value="1"
							<?php checked( $fetch_shop_btn_show_always, 1, true ); ?>
						/>
						Always
					</label>
				</div>
				<div>
					<label for="frenzy-shop-btn-show-hover">
						<input type="radio" id="frenzy-shop-btn-show-hover" name="fetch-shop-btn-show-always" value="0"<?php checked( $fetch_shop_btn_show_always, 0, true ); ?>
						/>
						When hovering on photos
					</label>
				</div>
				<p></p>
			</div>
		</div><!-- #frenzy-options-container -->
	</div>
	<div id="" class="settings-column">
		<?php $showHomeFeed = \Frenzy\Helpers\HelperFunctions::get_show_on_homepage(); ?>
		<h2 class="wp-heading-inline">Show on homepage feed</h2>
		<p>
			<input type="checkbox" name="fetch-show-home-feed" id="fetch-show-home-feed" <?php checked( $showHomeFeed, 1 ); ?> value="1"/>
			<label for="fetch-show-home-feed">Show shop button on homepage posts</label>
		</p>
	</div><!-- #frenzy-save-options -->

	<?php wp_nonce_field( 'frenzy-wordpress-plugin-settings', 'frenzy-wordpress-plugin' ); ?>
	<?php submit_button( 'Save', 'primary', 'frenzy-save-settings', false ); ?>
</form>
